(* * * * * * * * * * * * * * * * * * * * * * * *
 *        ⥪  ࠡ  BMP          *
 * * * * * * * * * * * * * * * * * * * * * * * *
 *           (c) 㫥订 .. 2000             *
 *             URL: pro3d.boom.ru              *
 *          e-mail: nord_ak@mail.ru            *
 * * * * * * * * * * * * * * * * * * * * * * * *)

unit MyBMP;

interface

var
  BMPmx, BMPmy : word;
  pic : array[0..40000] of byte;

procedure LoadBMP(s:string);
function gamma(c:byte;i:integer):byte;

implementation

type
  {  BMP 䠩 }
  THeader = record
    ID    : Word;      { 'BM' }
    FSize : LongInt;   {  䠩 }
    Ver   : LongInt;   {  ଠ }
    Image : LongInt;   { 饭  ࠦ }
    Misc  : LongInt;   { ? }
    X     : LongInt;   { ࠧ X }
    Y     : LongInt;   { ࠧ Y }
    Num   : Word;      { 1 }
    Bits  : Word;      { /pix ( 256 - 8) }
    Comp  : LongInt;   { 0 }
    ISize : LongInt;   { ࠧ ⨭   }
    XRes  : LongInt;   { X ࠧ襭 }
    YRes  : LongInt;   { Y ࠧ襭 }
    PSize : LongInt;   {  ⨭ }
    Res   : LongInt;   { ⭮ ࠧ襭 }
  end;

{ 㧪 BMP      }
procedure LoadBMP(s:string);
  var
    pal_new : array[0..255,0..2] of byte; {   }
    pal_bmp : array[0..255,0..2] of byte; {  BMP }
  { ⠭  室   }
  procedure paletsn(c1,c2,r1,g1,b1,r2,g2,b2:byte);
    var
      i,r,g,b : byte;
    begin
      for i := c1 to c2 do
        begin
          r := round(r1+(r2-r1)/(c2-c1)*(i-c1));
          g := round(g1+(g2-g1)/(c2-c1)*(i-c1));
          b := round(b1+(b2-b1)/(c2-c1)*(i-c1));
          pal_new[i,0] := r; pal_new[i,1] := g; pal_new[i,2] := b;
          port[$3c8] := i;
          port[$3c9] := r; port[$3c9] := g; port[$3c9] := b;
        end;
    end;
  {    }
  procedure SetCoolPal;
    var
      x, y, i, u : word;
    begin
      paletsn(0,15, 0,0,0, 63,63,63);
      for i := 0 to 5 do
        begin
          y := 16+(5-i)*35;
          x := 3+(i+1)*10+5*ord(i=0);
          paletsn(y+0, y+5,  x,0,0, x,x,0);
          paletsn(y+6, y+11, x,x,0, 0,x,0);
          paletsn(y+12,y+17, 0,x,0, 0,x,x);
          paletsn(y+18,y+23, 0,x,x, 0,0,x);
          paletsn(y+24,y+29, 0,0,x, x,0,x);
          paletsn(y+30,y+35, x,0,x, x,0,0);
        end;
    end;
  { ஢  BMP   }
  procedure adapt;
    var
      i, b, c : byte;
      ot, otl : longint;
    begin
      for c := 0 to 255 do
        begin
          otl := 200;
          for i := 0 to 230 do
            begin
              ot := (abs(pal_new[i,0]-pal_bmp[c,0])+
                     abs(pal_new[i,1]-pal_bmp[c,1])+
                     abs(pal_new[i,2]-pal_bmp[c,2])) div 3;
              if ot < otl then begin otl := ot; b := i; end;
            end;
          pal_bmp[c,0] := b;
        end;
    end;
  var
    f : file;
    r, g, b, c : byte;
    hdr : THeader;
    x, y : word;
  begin
    SetCoolPal;
    if s = '' then halt;
    assign(f,s);
    {$I-} reset(f,1); {$I+}
    if IOResult = 0 then
      begin
        blockread(f,hdr,54);
        if (hdr.bits = 8) and ((hdr.Y*hdr.X) < 40000) and (hdr.comp = 0) and (hdr.ID = $4D42) then
          begin
            for x := 0 to 255 do
              begin
                BlockRead(f,b,1);
                BlockRead(f,g,1);
                BlockRead(f,r,1);
                BlockRead(f,c,1);
                pal_bmp[x,0] := (r shr 2);
                pal_bmp[x,1] := (g shr 2);
                pal_bmp[x,2] := (b shr 2);
              end;
            adapt;
            BMPmy := hdr.Y - 1;
            BMPmx := hdr.ISize div hdr.Y - 1;
            seek(f,hdr.image);
            for y := 0 to BMPmy do
            for x := 0 to BMPmx do
              begin
                BlockRead(f,c,1);
                pic[y*(BMPmx+1)+x] := pal_bmp[c,0];
              end;
          end;
        close(f);
      end
    else
      halt;
  end;

{   i 梥 c }
function gamma(c:byte;i:integer):byte;
  var
    n, g : integer;
  begin
    if c > 15 then
      begin
        n := c - 16;
        c := n mod 35;
        g := n div 35;
        g := g - i;
        if (g < 0) then g := 0;
        if (g > 5) then g := 5;
        g := 16 + c + g * 35;
      end
    else
      begin
        g := c + i * 2;
        if (g > 15) then g := 15;
        if (g < 0) then g := 0;
      end;
    gamma := g;
  end;

BEGIN
END.
