unit MyGraph;


interface

uses Graph, General;

function MyInitGraph : boolean;
procedure ShowPrompts(X,Y: integer; Prompt : string; Color: byte);
procedure MyClose;
procedure MyDrawPoly(Poly : array of TCoordinates;Style : byte);
procedure MyLine(Points : array of TCoordinates;Style : byte);
procedure MySetColor(Color : byte);
implementation


procedure MyDrawPoly(Poly : array of TCoordinates;Style : byte);
var i : byte;

begin
  SetLineStyle(Style,0,1);
  MoveTo(Poly[3].Y,Poly[3].X);
  for i := 0 to 3 do
    LineTo(Poly[i].Y,Poly[i].X);
end;

procedure MyLine(Points : array of TCoordinates;Style : byte);
begin
 SetLineStyle(Style,0,1);
 MoveTo(Points[0].Y,Points[0].X);
 LineTo(Points[1].Y,Points[1].X);
end;

procedure MySetColor(Color : byte);
begin
 SetColor(Color);
end;

function MyInitGraph : boolean;
var
    grDriver, grMode : integer;

begin
  grDriver := Detect;
  InitGraph(grDriver, grMode,'');
  if grOk <> 0 then
     MyInitGraph := false
   else
     MyInitGraph := true;
end;

procedure MyClose;
begin
  CloseGraph;
end;

procedure ShowPrompts(X,Y: integer; Prompt : string;
              Color : byte);
begin
  SetColor(Color);
  OuttextXY(X,Y,prompt);
end;

End.