unit KirusBek;

interface
uses crt,graph;
const NumberOfPoints=50;
Type TPoint=record
     x,y:longint;
     end;
Type TPoints=record
     Point1,Point2:TPoint;
     end;
var
  k:integer;
  p:TPoints;
  n,f:array [0..NumberOfPoints] of TPoint;

procedure ClearScreen;
function CheckNewFigure(NOP:integer):boolean;
function scal(var x1,y1,x2,y2:longint):longint;
procedure setfigure1;
procedure setfigure2;
procedure drawfigure(NOP:integer);
procedure KirusBeck(var f,n:array of TPoint;var p1,p2:TPoint;var VerNum:integer;var result:TPoints);
procedure UpgradedKirusBeck(var f,n:array of TPoint;var p1,p2:TPoint;var VerNum:integer;var result:TPoints);


implementation

procedure ClearScreen;
begin
SetFillStyle(1, 0);
Bar(0,0,getmaxx,getmaxy);

end;

function scal(var x1,y1,x2,y2:longint):longint;
  begin
  scal:=x1*x2+y1*y2;
  end;

procedure setfigure1;
  begin
  f[0].x:=150;
  f[0].y:=100;
  f[1].x:=350;
  f[1].y:=150;
  f[2].x:=250;
  f[2].y:=300;
  k:=3;
  end;

procedure setfigure2;
  begin
  f[0].x:=150;
  f[0].y:=100;
  f[1].x:=350;
  f[1].y:=100;
  f[3].x:=150;
  f[3].y:=300;
  f[2].x:=350;
  f[2].y:=300;
  k:=4;
  end;

procedure drawfigure(NOP:integer);
  var i:integer;
  begin
  moveto(f[0].x,f[0].y);
  for i:=1 to nop-1 do
    lineto(f[i].x,f[i].y);
  lineto(f[0].x,f[0].y);
  end;

function CheckNewFigure(NOP:integer):boolean;
var i:integer;
    z:array [0..NumberOfPoints] of longint;
    vector:array [0..NumberOfPoints] of TPoint;
begin
CheckNewFigure:=true;
for i:=0 to nop-2 do
  begin
  vector[i].x:=f[i+1].x-f[i].x;
  vector[i].y:=f[i+1].y-f[i].y;
  end;
vector[nop-1].x:=f[0].x-f[nop-1].x;
vector[nop-1].y:=f[0].y-f[nop-1].y;

for i:=0 to nop-2 do
  z[i]:=(vector[i].x*vector[i+1].y)-(vector[i].y*vector[i+1].x);
z[nop-1]:=(vector[nop-1].x*vector[0].y)-(vector[nop-1].y*vector[0].x);

for i:=0 to nop-1 do
  if z[i]>0 then z[i]:=1
            else z[i]:=-1;

for i:=0 to nop-1 do
  if z[0]*z[i]<0 then
    CheckNewFigure:=false;

for i:=0 to nop-1 do
  begin
  n[i].x:=-z[i]*vector[i].y;
  n[i].y:=z[i]*vector[i].x;
  end;
for i:=0 to nop-1 do
  while((abs(n[i].x)>1000) or (abs(n[i].y)>1000)) do
    begin
    n[i].x:=round(n[i].x/10);
    n[i].y:=round(n[i].y/10);
    end;

end;

procedure KirusBeck(var f,n:array of TPoint;var p1,p2:TPoint;var VerNum:integer;var result:TPoints);
var i,ds,ws:longint;
    t,tv,tn:real;
    d,w:array[1..2]of longint;
    NormalExit:boolean;
begin
NormalExit:=false;
tn:=0;
tv:=1;
d[1]:=p2.x-p1.x;
d[2]:=p2.y-p1.y;
for i:=0 to (VerNum-1) do
  begin
  w[1]:=p1.x-f[i].x;
  w[2]:=p1.y-f[i].y;
  ds:=scal(d[1],d[2],n[i].x,n[i].y);
  ws:=scal(w[1],w[2],n[i].x,n[i].y);
  if ds=0 then
    begin
    if ws<0 then break;
    end
  else
    begin
    t:=-(ws/ds);
    if ds>0 then
      begin
      if t>1 then break;
      if t>tn then tn:=t;
      if i=vernum-1 then  NormalExit:=true;
      continue;
      end;
    if t<0 then break;
    if t<tv then tv:=t;
    end;
  if i=vernum-1 then  NormalExit:=true;
  end;

if ((tn<tv)and(NormalExit=true)) then
  begin
  result.Point1.x:=round(p1.x+(p2.x-p1.x)*tn);
  result.Point1.y:=round(p1.y+(p2.y-p1.y)*tn);
  result.Point2.x:=round(p1.x+(p2.x-p1.x)*tv);
  result.Point2.y:=round(p1.y+(p2.y-p1.y)*tv);
  moveto(result.Point1.x,result.Point1.y);
  lineto(result.Point2.x,result.Point2.y);
  end;
end;

procedure UpgradedKirusBeck(var f,n:array of TPoint;var p1,p2:TPoint;var VerNum:integer;var result:TPoints);
var i,ds,ws:longint;
    t,tv,tn:real;
    d,w:array[1..2]of longint;
begin

tn:=0;
tv:=1;
d[1]:=p2.x-p1.x;
d[2]:=p2.y-p1.y;
for i:=0 to (VerNum-1) do
  begin
  w[1]:=p1.x-f[i].x;
  w[2]:=p1.y-f[i].y;
  ds:=scal(d[1],d[2],n[i].x,n[i].y);
  ws:=scal(w[1],w[2],n[i].x,n[i].y);
  if ds=0 then
    begin
    if ws<0 then
              begin
              tv:=1;
              tn:=1;
              break;
              end;
    end
  else
    begin
    t:=-(ws/ds);
    if ds>0 then
      begin
      if t>1 then
              begin
              tv:=1;
              tn:=1;
              break;
              end;

      if t>tn then tn:=t;
      continue;
      end;
    if t<0 then begin
                tv:=1;
                tn:=1;
                break;
                end;
    if t<tv then tv:=t;
    end;
  end;
  result.Point1.x:=round(p1.x+(p2.x-p1.x)*tn);
  result.Point1.y:=round(p1.y+(p2.y-p1.y)*tn);
  result.Point2.x:=round(p1.x+(p2.x-p1.x)*tv);
  result.Point2.y:=round(p1.y+(p2.y-p1.y)*tv);
  if (p1.x<>result.Point1.x)and(p1.y<>result.Point1.y) then
    begin
    MoveTo(p1.x,p1.y);
    LineTo(result.Point1.x,result.Point1.y);
    end;
  if (p2.x<>result.Point2.x)and(p2.y<>result.Point2.y) then
    begin
    MoveTo(p2.x,p2.y);
    LineTo(result.Point2.x,result.Point2.y);
    end;
end;

end.